/**
  *  \file client/dlg-list.h
  *
  *  (c) 2001-2010 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_LISTSHIP_H
#define PCC_V2_CLIENT_LISTSHIP_H

#include "game/objlist.h"
#include "game/coord.h"
#include "cpluslib/string.h"
#include "client/cscreen.h"
#include "cpluslib/sigslot.h"
#include "ui/listbox.h"


class WObjectSelectionList : public UIListbox {
    GObjectList&  list;
    int           info_space;

    SignalConnection conn_univ_change;
    SignalConnection conn_turn_change;

    void onTurnChange();
    void onUniverseChange();
 protected:
    void setInfoSpace(int aspace) { info_space = aspace; }
    virtual string_t getObjectInfo(GObjectId obj);
 public:
    WObjectSelectionList(int id, int lines, int width, GObjectList& list);
    ~WObjectSelectionList();

    /* UIListbox interface */
    void       drawPart(GfxCanvas& can, int from, int to);
    bool       isAccessible(int index);

    /* Accessors */
    bool       selectObject(GObjectId id);
    GObjectId  getCurrentObject() const { return list.getObjectId(getCurrent()+1); }

    void       onListChange(GObjectId objectToSelect);

    /* Convenience Interface */
    GObjectId  doStandardDialog(string_t title, int help_id);
};

#endif
