/**
  *  \file client/remote.h
  *
  *  (c) 2001-2010 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_REMOTE_H
#define PCC_V2_CLIENT_REMOTE_H

#include "client/wcolorframe.h"

class GCommandContainer;
class GShip;

/** Remote control state summary. */
enum TRemoteControlSetting {
    rc_Forbidden,                   ///< Own ship, RC disallowed.
    rc_Normal,                      ///< Own ship, normal.
    rc_RemoteControlled,            ///< Enemy ship, we control it.
    rc_Applying,                    ///< Enemy ship, control requested.
    rc_Dropping,                    ///< Enemy ship, control being given back.
    rc_Other,                       ///< Enemy ship, normal (we don't control).
    rc_OtherForbidden,              ///< enemy ship, RC disallowed.
    rc_OurRemoteControlled          ///< Own ship under foreign control
};

TRemoteControlSetting getOldRemoteControlState(const GShip& sh);
TRemoteControlSetting getNewRemoteControlState(const GShip& sh, GCommandContainer& cmds);
TFrameColor           getRemoteControlColor(TRemoteControlSetting v);

void doRemoteControl(GShip& sh, GCommandContainer& cmds);

#endif
